//+------------------------------------------------------------------+
//|                                 Ehlers 2 Pole Butterwotrh filter |
//|                             Ehlers 2 Pole Butterwotrh filter.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

//
//
//
//
//

extern int TPSSPeriod  = 15;
extern int TPSSPrice   = PRICE_MEDIAN;
double     tpssBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,tpssBuffer);
   IndicatorShortName("Ehlers\' 2 Pole Butterwotrh filter ("+TPSSPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit;
   int i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   for(i=limit; i>=0; i--) tpssBuffer[i] = iTpss(TPSSPeriod,TPSSPrice,i);
   return(0);
}

  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

#define Pi 3.141592653589793238462643

double iTpss(int period,int priceType,int i)
{
   if (i > Bars-3) return(iMA(NULL,0,1,0,MODE_SMA,priceType,i));
   
   //
   //
   //
   //
   //
   
   double a = MathExp(-1.414*Pi/period);
   double b = 2*a*MathCos(1.414*Pi/period);

      double coef2 = b;
      double coef3 = -a*a;
      double coef1 = (1-b+a*a)/4;
   
      double price1 = iMA(NULL,0,1,0,MODE_SMA,priceType,i);
      double price2 = iMA(NULL,0,1,0,MODE_SMA,priceType,i+1);
      double price3 = iMA(NULL,0,1,0,MODE_SMA,priceType,i+2);

   double tpss = coef1*(price1+2*price2+price3)+coef2*tpssBuffer[i+1]+coef3*tpssBuffer[i+2];
   return(tpss);
}